var dmActiveDownloads  = [];
var focused = true;

window.addEventListener("click", onDownloadSelect, false);
window.addEventListener("focus", dmFocused, false);
window.addEventListener("blur", dmBlurred, false);

function dmFocused(aEvent)
{
  focused = true;
}

function dmBlurred(aEvent)
{
  focused = false;
}

function onDownloadSelect(aEvent)
{
  if (gDownloadsView.selected) {
    var st = parseInt(gDownloadsView.selected.getAttribute("state"));
    if (st < 0)
      st = 0;

    switch (st) {
    case 0:  // Downloading
      document.getElementById("dmStartButton").disabled = true;
      document.getElementById("dmLaunchButton").disabled = true;
      document.getElementById("dmShowButton").disabled = true;
      document.getElementById("dmStartButton2").disabled = true;
      document.getElementById("dmLaunchButton2").disabled = true;
      document.getElementById("dmShowButton2").disabled = true;
      break;
    case 1:  // Done
      document.getElementById("dmStartButton").disabled = false;
      document.getElementById("dmLaunchButton").disabled = false;
      document.getElementById("dmShowButton").disabled = false;
      document.getElementById("dmStartButton2").disabled = false;
      document.getElementById("dmLaunchButton2").disabled = false;
      document.getElementById("dmShowButton2").disabled = false;
      break;
    case 2:  // Failed
    case 3:  // Canceled
      document.getElementById("dmStartButton").disabled = false;
      document.getElementById("dmLaunchButton").disabled = true;
      document.getElementById("dmShowButton").disabled = true;
      document.getElementById("dmStartButton2").disabled = false;
      document.getElementById("dmLaunchButton2").disabled = true;
      document.getElementById("dmShowButton2").disabled = true;
      break;
    case 4:  // Paused
      document.getElementById("dmStartButton").disabled = false;
      document.getElementById("dmLaunchButton").disabled = true;
      document.getElementById("dmShowButton").disabled = true;
      document.getElementById("dmStartButton2").disabled = false;
      document.getElementById("dmLaunchButton2").disabled = true;
      document.getElementById("dmShowButton2").disabled = true;
      break;
    case 7:  // Install Done
      document.getElementById("dmStartButton").disabled = true;
      document.getElementById("dmLaunchButton").disabled = true;
      document.getElementById("dmShowButton").disabled = true;
      document.getElementById("dmStartButton2").disabled = true;
      document.getElementById("dmLaunchButton2").disabled = true;
      document.getElementById("dmShowButton2").disabled = true;
      break;
    default:
      document.getElementById("dmStartButton").disabled = true;
      document.getElementById("dmLaunchButton").disabled = true;
      document.getElementById("dmShowButton").disabled = true;
      document.getElementById("dmStartButton2").disabled = true;
      document.getElementById("dmLaunchButton2").disabled = true;
      document.getElementById("dmShowButton2").disabled = true;
      break;
    }
  }
}


function dmCompleted(aDownload)
{
  try {
    // Remove the download from our book-keeping list and if the count
    // falls to zero, update the title here, since we won't be getting
    // any more progress notifications in which to do it.
    for (var i = 0; i < dmActiveDownloads.length; ++i) {
      if (dmActiveDownloads[i] == aDownload) {
        dmActiveDownloads.splice(i, 1);
        break;
      }
    }
  }
  catch (e) {
  }
}

var dmDownloadObserver = {
  observe: function (aSubject, aTopic, aState)
  {
    var pref = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
    switch (aTopic) {
    case "dl-done":
      var dl = aSubject.QueryInterface(Components.interfaces.nsIDownload);
      dmCompleted(dl);

	  try {
	 	var close = pref.getBoolPref("downloadmgr.closeWhenDone");
	  } catch (e) {}

	  if (close != false && dmActiveDownloads.length == 0 && !focused) window.close();
      break;
    case "dl-failed":
    case "dl-cancel":
      var dl = aSubject.QueryInterface(Components.interfaces.nsIDownload);
      dmCompleted(dl);
      break;
    case "dl-start":
      // Add this download to the percentage average tally
      var dl = aSubject.QueryInterface(Components.interfaces.nsIDownload);
      dmActiveDownloads.push(dl);
	  try {
	 	var show = pref.getBoolPref("downloadmgr.showWhenStarting");
	  } catch (e) {}

	  if (show != false) toggleDownloadMgr(true,false);
      break;
    }
  }
};


function dmInit()
{
  var preferencesService = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("");

  try {

  // Start an observer to close the separate Download Manager window
  var window = preferencesService.getIntPref("downloadmgr.windowType");
  if (window != 1 && window != 2) {
    var observerService = Components.classes["@mozilla.org/observer-service;1"].getService(Components.interfaces.nsIObserverService);
    observerService.addObserver(dmDownloadObserver, "dl-done",   false);
    observerService.addObserver(dmDownloadObserver, "dl-start",  false);
  }

  var bottom = preferencesService.getBoolPref("downloadmgr.bottomToolBar");
  if (bottom) document.getElementById("topToolBar").hidden="true";
  else document.getElementById("bottomToolBar").hidden="true";

  var dlButton = preferencesService.getBoolPref("downloadmgr.buttonDownload");
  if (!dlButton) {
	document.getElementById("dmStartButton").hidden="true";
	document.getElementById("dmStartButton2").hidden="true";
	document.getElementById("dmStartSep").hidden="true";
	document.getElementById("dmStartSep2").hidden="true";
  }

  var launchButton = preferencesService.getBoolPref("downloadmgr.buttonLaunch");
  if (!launchButton) {
	document.getElementById("dmLaunchButton").hidden="true";
	document.getElementById("dmLaunchButton2").hidden="true";
	document.getElementById("dmLaunchSep").hidden="true";
	document.getElementById("dmLaunchSep2").hidden="true";
  }

  var showButton = preferencesService.getBoolPref("downloadmgr.buttonShow");
  if (!showButton) {
	document.getElementById("dmShowButton").hidden="true";
	document.getElementById("dmShowButton2").hidden="true";
	document.getElementById("dmShowSep").hidden="true";
	document.getElementById("dmShowSep2").hidden="true";
  }

  var cleanButton = preferencesService.getBoolPref("downloadmgr.buttonClean");
  if (!cleanButton) {
	document.getElementById("dmCleanUpButton").hidden="true";
	document.getElementById("dmCleanUpButton2").hidden="true";
  }

  var optionsButton = preferencesService.getBoolPref("downloadmgr.buttonOptions");
  if (!optionsButton) {
	document.getElementById("dmOptionsButton").hidden="true";
	document.getElementById("dmOptionsButton2").hidden="true";
  }
  } catch (e) {}
}
